
#include <boost/lexical_cast.hpp>
#include <Wt/WApplication>
#include <Wt/WText>
#include <Wt/WImage>
#include <Wt/WPushButton>
#include <boost/filesystem/operations.hpp>
#include <boost/filesystem/exception.hpp>
#include <Wt/WOverlayLoadingIndicator>
#include <FileTreeList.h>
#include <FileTreeNode.h>


using namespace Wt;
using std::rand;

FileTreeList::FileTreeList(const std::string& path, WContainerWidget *parent)
        : WContainerWidget(parent), m_path(path)
{
    boost::filesystem::path boostPath(path);
    if (boost::filesystem::exists(boostPath))
    {
        if (boost::filesystem::is_directory(boostPath) || boost::filesystem::is_regular_file(boostPath))
        {

            WCssDecorationStyle treeNodeLabelStyle;
            treeNodeLabelStyle.font().setFamily(WFont::Serif, "Helvetica");
            WApplication::instance()->styleSheet().addRule(".treenodelabel", treeNodeLabelStyle);

            WApplication::instance()->styleSheet().addRule(".treenodechildcount",
                                      "color:blue; font-family:Helvetica,serif;");

            WApplication::instance()->setLoadingIndicator(new Wt::WOverlayLoadingIndicator());

            tree_ = new FileTreeNode(boostPath, this);
            addWidget(tree_);
        }
    }
}

bool FileTreeList::GetCheckedFile(std::string& path)
{
    if (tree_ && tree_->checkedNode != NULL)
    {
        path = tree_->checkedNode->m_path.string();
        return true;
    }
    return false;
}

